import java.awt.*;
class Main extends Frame {
    Color[] cbColor = {Color.red, Color.green, Color.blue};
    String[] cbName = {"Red", "Green", "Blue"};
    MainCanvas[] cbCanvas = new MainCanvas[3];
    CheckboxGroup cgroup = new CheckboxGroup();

    Main() {
        super("CheckboxGroup Example");
        Panel p = new Panel(), colorPanel = new Panel();

        p.setLayout(new GridLayout(0, 1));
        colorPanel.setLayout(new GridLayout(1, 0));
        for (int i=0; i<cbColor.length; i++) {
            Checkbox cb = new Checkbox(cbName[i], cgroup, i == 0);
            p.add(cb);
            colorPanel.add(cbCanvas[i] = new MainCanvas(cbColor[i], cb));
            cbCanvas[i].resize(70, 70);
        }
        add("West", p);
        add("Center", colorPanel);
        pack();
        show();
    }

    public boolean action(Event evt, Object what) {
        if (evt.target instanceof Checkbox) {
            for (int i=0; i<cbCanvas.length; i++) {
                cbCanvas[i].repaint();
            }
            return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Checkbox cb;

    MainCanvas(Color color, Checkbox cb) {
        setBackground(color);
        this.cb = cb;
    }

    public boolean mouseDown(Event evt, int x, int y) {
        cb.getCheckboxGroup().setCurrent(cb);
        // repaint all sibling canvases.
        for (int i=0; i<getParent().countComponents(); i++) {
            getParent().getComponent(i).repaint();
        }
        return true;
    }

    public void paint(Graphics g) {
        if (cb.getCheckboxGroup().getCurrent() == cb) {
            Dimension d = size();
            g.setColor(Color.black);
            g.fillOval(d.width/3, d.height/3, d.width/3, d.height/3);
        }
    }
}
