import java.awt.*;
import java.awt.peer.ContainerPeer;
class Main extends Frame {
    Main() {
        super("insets Example");
        Panel p = new MainPanel(new GridLayout(0, 1), 8);
        Canvas cv;

        p.add(cv = new Canvas());
        cv.setBackground(Color.black);
        p.add(cv = new Canvas());
        cv.setBackground(Color.white);
        add("Center", p);
        resize(150, 200);
        show();
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainPanel extends Panel {
    int borderSize;

    MainPanel(LayoutManager layout, int size) {
        setLayout(layout);
        borderSize = size;
    }

    public Insets insets() {
        Insets insets = super.insets();
        insets.top += borderSize;
        insets.left += borderSize;
        insets.bottom += borderSize;
        insets.right += borderSize;
        return insets;
    }

    // Use the peer's insets to determine the size of the paintable area.
    public void paint(Graphics g) {
        Insets insets = ((ContainerPeer)getPeer()).insets();
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;

        g.setColor(new Color(200, 100, 100));
        for (int i=0; i<borderSize; i++) {
            g.draw3DRect(i, i, w-2*i-1, h-2*i-1, i<borderSize/2);
        }
    }

    public boolean mouseMove(Event evt, int x, int y) {
        System.out.println(x + "," + y);
        return true;
    } 
}
