import java.awt.*;
class Main extends Frame {
    Main() {
        super("drawRoundRect Example");
        add("Center", new MainCanvas());
        resize(150, 80);
        show();
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    String label = "Round Button";
    boolean down;

    public boolean mouseDown(Event evt, int x, int y) {
        down = true;
        repaint();
        return true;
    }

    public boolean mouseUp(Event evt, int x, int y) {
        down = false;
        repaint();
        return true;
    }

    public void paint(Graphics g) {
        int w = size().width;
        int h = size().height;
        FontMetrics fm = g.getFontMetrics();

        if (down) {
            g.setColor(Color.red);
        } else {
            g.setColor(Color.black);
        }
        g.drawRoundRect(0, 0, w-1, h-1, 20, 20);
        g.drawString(label, (w-fm.stringWidth(label))/2, 
            (h-fm.getHeight())/2+fm.getAscent());
    }
}
