import java.awt.*;
class Main extends Frame {
    int curX, curY, newX, newY;

    Main() {
        super("setXORMode Example");
        resize(200, 200);
        show();
    }

    public boolean mouseMove(Event evt, int x, int y) {
        newX = x;
        newY = y;
        repaint();
        return true;
    }

    void drawLines(Graphics g, int x, int y, int w, int h) {
        g.setXORMode(Color.green);
        g.setColor(Color.red);
        g.drawLine(0, 0, x, y);
        g.setColor(Color.green);
        g.drawLine(w, 0, x, y);
        g.setColor(Color.blue);
        g.drawLine(0, h, x, y);
        g.setColor(Color.yellow);
        g.drawLine(w, h, x, y);
        g.setColor(Color.black);
        g.fillOval(x-20, y-20, 40, 40);
    }

    public void update(Graphics g) {
        Insets insets = this.insets();
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;

        // Erase old image.
        drawLines(g, curX, curY, w, h);
        // Paint new one.
        drawLines(g, newX, newY, w, h);
        curX = newX;
        curY = newY;
    }

    public void paint(Graphics g) {
        Insets insets = this.insets();
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;

        g.setPaintMode();
        g.setColor(Color.red);
        g.fillRect(0, 0, w/3, h);
        g.setColor(Color.green);
        g.fillRect(w/3, 0, w/3, h);
        g.setColor(Color.blue);
        g.fillRect(w*2/3, 0, w/3, h);
        g.setColor(Color.black);
        g.fillRect(0, h/3, w, h/3);
        drawLines(g, newX=curX=w/2, newY=curY=h/2, w, h);
    }

    static public void main(String[] args) {
        new Main();
    }
}
