import java.awt.*;
class Main extends Frame {
    MainCanvas cv = new MainCanvas();
    Scrollbar sb = new Scrollbar(Scrollbar.VERTICAL, 0, 50, 0, 100);

    Main() {
        super("translate Example");
        add("Center", cv);
        add("East", sb);
        resize(200, 200);
        show();
    }

    public boolean handleEvent(Event evt) {
        if (evt.target == sb) {
            cv.setOrigin(0, -cv.size().height * sb.getValue() / 100);
            return true;
        }
        return super.handleEvent(evt);
    }

    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    int thick;
    double[] values = new double[100];
    int curX, curY;
    int originX, originY;

    MainCanvas() {
        for (int i=0; i<values.length; i++) {
            values[i] = Math.random();
        }
    }

    void setOrigin(int x, int y) {
        originX = x;
        originY = y;
        repaint();
    }

    public void paint(Graphics g) {
        int w = size().width;
        thick = size().height*2/values.length;

        g.translate(originX, originY);
        for (int i=0; i<values.length; i++) {
            int c = (int)(Math.floor(255 * values[i]));
            if (curY >= i * thick && curY < (i+1) * thick) {
                g.setColor(Color.red);
            } else {
                g.setColor(new Color(c, c, c));
            }
            g.fillRect(0, i * thick, (int)(w * values[i]), thick);
        }
    }

    public boolean mouseDown(Event evt, int x, int y) {
        curX = x - originX;
        curY = y - originY;
        repaint();
        return true;
    }
}
