import java.awt.*;
import java.awt.image.*;
import java.net.*;
class Main extends Frame {
    Main(String filename) {
        super("getGraphics Example");
        try {
            // Retrieve the image.
            URL url = new URL("file:///" + System.getProperty("user.dir")
               + "/" + filename);

            add("Center", new ImageCanvas(getToolkit().getImage(url)));
        } catch (Exception e) {
            e.printStackTrace();
        }
        resize(200, 200);
        show();
    }

    static public void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("usage: java Main <image file>");
        }
    }
}

class ImageCanvas extends Canvas {
    Image image;
    Image backBuffer;
    Graphics backBufferG;

    ImageCanvas(Image image) {
        this.image = image;
        prepareImage(image, this);
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        if (backBuffer == null) {
            if (g.drawImage(image, 0, 0, this) && backBuffer == null) {
                int w = image.getWidth(this);
                int h = image.getHeight(this);

                backBuffer = createImage(w, h);
                backBufferG = backBuffer.getGraphics();
                backBufferG.setColor(getBackground());
                backBufferG.fillRect(0, 0, w, h);
                backBufferG.drawImage(image, 0, 0, this);
            }
            return;
        }
        g.drawImage(backBuffer, 0, 0, this);
    }

    public boolean mouseDrag(Event evt, int x, int y) {
        backBufferG.setColor(Color.red);
        backBufferG.fillOval(x, y, 5, 5);
        repaint();
        return true;
    }
}
