import java.awt.*;
import java.util.*;
class Main extends Frame {
    Vector commands = new Vector();
    Menu m = new Menu("Commands");

    Main() {
        super("Menu Example");
        MenuBar mb = new MenuBar();

        // Add menu to menu bar.
        mb.add(m);

        // Set the menu bar on the frame.
        setMenuBar(mb);
        add("South", new TextField());
        resize(100, 50);    
        show();
    }

    void updateMenu(Menu m) {
        // First remove all the menu items.
        while (m.countItems() > 0) {
            m.remove(0);
        }
        // Then add them back in.
        for (int i=0; i<commands.size(); i++) {
            m.add((String)commands.elementAt(i));
        }
    }

    public void addCommand(String cmd) {
        for (int i=0; i<m.countItems(); i++) {
            MenuItem mi = (MenuItem)m.getItem(i);
            if (mi.getLabel().equals(cmd)) {
                // Move command to top of list.
                commands.removeElementAt(i);
                commands.insertElementAt(cmd, 0);
                updateMenu(m);
                return;
            }
        }
        if (m.countItems() >= 10) {
            // Remove last command from list.
            commands.removeElementAt(commands.size()-1);
        }
        commands.insertElementAt(cmd, 0);
        updateMenu(m);
    }

    public boolean action(Event evt, Object what) {
        if (evt.target instanceof TextField) {
            addCommand((String)what);
            return true;
        }
        return false;
    }

    static public void main(String[] args) {
        new Main();
    }
}
