import java.io.FileInputStream;
import java.io.File;
import java.io.IOException;
import java.io.FileNotFoundException;

class Main {
    // read a file and print out all the non-spaces
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: java Main <input_file>");
            System.exit(-1);
        }
        File file = new File(args[0]);
        try {
            FileInputStream in = new FileInputStream(file);
            int c;

            while ((c=in.read()) > -1) {
                if (!Character.isSpace((char)c))
                    System.out.print((char)c);
            }
            in.close();
            System.out.flush();
        } catch (FileNotFoundException e) {
            System.err.println(file + " is not found");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
