import java.io.LineNumberInputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

class LCount {
    // prints the number of lines and bytes in a file
    // and prints the first 100 bytes of that file
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: java LCount <file>");
            System.exit(-1);
        }
        try {
            LineNumberInputStream in = 
                new LineNumberInputStream(
                new BufferedInputStream(new FileInputStream(args[0])));

            int bytecount = in.available();
            in.mark(bytecount); // mark at beginning of stream
            in.skip(bytecount); // skip to end of buffer
            int linecount = in.getLineNumber();

            System.out.println("\t" + linecount + "\t" + bytecount +
                               "\t" + args[0]);
            in.reset();        
            int i, c;
            for (i = 0; i < 100 && ((c = in.read()) > -1); i++)
                System.out.write(c);
            if (i >= 100) 
                System.out.println("\n...");
            System.out.flush();               // flush output

            in.close();

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
