/*
    This example creates two different execution stacks 
    and shows the class depth values of classes on 
    those stacks. Since the classDepth() method is 
    protected, it can not be called directly. Hence, 
    this example creates a subclass of SecurityManager 
    with a public method that provides access to the 
    classDepth() method.
*/
public class Main {
    public static void main(String[] args) {
        MySecurityManager sm = new MySecurityManager();

        System.setSecurityManager(sm);
        sm.printClassDepth("C");                    // -1
        sm.printClassDepth("MySecurityManager");    // 0
        sm.printClassDepth("Main");                 // 1

        C.printClassDepth("C");                     // 1
        C.printClassDepth("MySecurityManager");     // 0
        C.printClassDepth("Main");                  // 2
    }
}

class MySecurityManager extends SecurityManager {
    public void printClassDepth(String name) {
        System.out.println(classDepth(name));
    }
}

class C {
    static void printClassDepth(String name) {
        ((MySecurityManager)System.getSecurityManager()).printClassDepth(name);
    }
}
